/*
  LiquidCrystal Library - display() and noDisplay()
 
 Demonstrates the use a 16x2 LCD display.  The LiquidCrystal
 library works with all LCD displays that are compatible with the 
 Hitachi HD44780 driver. There are many of them out there, and you
 can usually tell them by the 16-pin interface.
 
 This sketch prints "Hello World!" to the LCD and uses the 
 display() and noDisplay() functions to turn on and off
 the display.
 
 The circuit:
 * LCD RS pin to digital pin 12
 * LCD Enable pin to digital pin 11
 * LCD D4 pin to digital pin 5
 * LCD D5 pin to digital pin 4
 * LCD D6 pin to digital pin 3
 * LCD D7 pin to digital pin 2
 * LCD R/W pin to ground
 * 10K resistor:
 * ends to +5V and ground
 * wiper to LCD VO pin (pin 3)
 
 Library originally added 18 Apr 2008
 by David A. Mellis
 library modified 5 Jul 2009
 by Limor Fried (http://www.ladyada.net)
 example added 9 Jul 2009
 by Tom Igoe 
 modified 22 Nov 2010
 by Tom Igoe

 This example code is in the public domain.

 http://arduino.cc/en/Tutorial/LiquidCrystalDisplay

 */


// include the library code:
//Módulo estándar
#include <LiquidCrystal.h>
// E  8
// RW 9
// RS 10
// DB0..7 7..0
// initialize the library with the numbers of the interface pins
LiquidCrystal lcd(10, 9, 8, 7, 6, 5, 4, 3, 2, 1, 0);
//LiquidCrystal lcd(10, 8, 7, 6, 5, 4, 3, 2, 1, 0);
//LiquidCrystal lcd(10, 9, 8, 3, 2, 1, 0);
//LiquidCrystal lcd(10, 8, 3, 2, 1, 0);

void setup() {
  // set up the LCD's number of columns and rows: 
  lcd.begin(20, 4);
}

void loop() {
byte i;
int j;

  lcd.clear();

  // Print a message to the LCD.
  lcd.print("1 hello, world!");
  lcd.setCursor(64, 0);
  lcd.print("2 hello, world!");
  lcd.setCursor(20, 0);
  lcd.print("3 hola ol");
  lcd.write(0xE3); // epsilon???
  lcd.print("!");
  lcd.setCursor(84, 0);
  lcd.print("4 Vamos de ca");
  lcd.write(0xEE); // ñ
  lcd.print("as???");

  delay(1000);

// shift del display
    for(i=0; i<20; i++){
    lcd.scrollDisplayLeft();
    delay (100);
  }

  delay(1000);

// Parte alta del juego de caracteres
  lcd.clear();

  for (i=0xc0; i<0xc0+16; i++){
    lcd.write(i);
    delay(100);
  }
  lcd.setCursor(64, 0);
  for (i=0xd0; i<0xd0+16; i++){
    lcd.write(i);
    delay(100);
  }
  lcd.setCursor(20, 0);
  for (i=0xe0; i<0xe0+16; i++){
    lcd.write(i);
    delay(100);
  }
  lcd.setCursor(84, 0);
  for (i=0xf0; i<0xf0+15; i++){ //i: 0..ff->0..ff  0xf0+16=0
    lcd.write(i);
    delay(100);
  }
    lcd.write(i); // i = 0xff

  delay(1000);

// Print con autoscroll
  lcd.clear();

  lcd.print("1 hello, world!");
  lcd.setCursor(64, 0);
  lcd.print("2 Vamos de ca");
  lcd.cursor();
  lcd.autoscroll();
  lcd.write(0xEE); // ñ
  delay(500);
  lcd.print('a');
  delay(500);
  lcd.print('s');
  delay(500);
  lcd.print('?');
  delay(500);
  lcd.print('?');
  delay(500);
  lcd.print('?');
  lcd.noAutoscroll();

  delay(1000);

// Intercambiar pantalla, parte izquierda/derecha
// Esta parte no tiene sentido en un módulo 4x20
  lcd.setCursor(20, 0);
  for (i=0xe0; i<0xe0+16; i++){
    lcd.write(i);
  }
  lcd.setCursor(84, 0);
  for (j=0xf0; j<0xf0+16; j++){ //otra forma de programar el bucle evitando el desbordamiento del índice
    lcd.write(j%256);
  }

  lcd.home();
  for (j=0; j<3; j++){
    delay(1000);
    for (i=0; i<20; i++) lcd.scrollDisplayLeft();
    delay(1000);
    for (i=0; i<20; i++) lcd.scrollDisplayRight();
  }
  
// Desplazar el cursor
  lcd.cursor();
  for (j=0; j<1; j++){
      for (i=0; i<16; i++){
        lcd.setCursor(i, 0);
        delay(100);
      }
      for (i=15; i>=1; i--){
        lcd.setCursor(i, 0);
        delay(100);
      }
      lcd.setCursor(i, 0);
      delay(100);

      for (i=64; i<80; i++){
        lcd.setCursor(i, 0);
        delay(100);
      }
      for (i=79; i>=64; i--){
        lcd.setCursor(i, 0);
        delay(100);
    }
  }

// Cursor con parpadeo
  lcd.blink();
  for (j=0; j<1; j++){
      for (i=0; i<8; i++){
        lcd.setCursor(i, 0);
        delay(1000);
      }

      for (i=71; i>=64; i--){
        lcd.setCursor(i, 0);
        delay(1000);
    }
  }
  lcd.noBlink();

// Parpadeo del display
  for (j=0; j<2; j++){
    lcd.noDisplay();
    delay(1000);
    lcd.display();
    delay(1000);
  }

// Formatear texto
char s1[21]; // string de 20 caracteres + el terminador 0x00
char s2[21];
char s3[21];
byte h=3, m=23, s=7, c=85;

  lcd.clear();

  for (j=0; j<9; j++){
    lcd.home();
    sprintf(s1, "hora %2d:%02d:%02d:%02d", h++, m--, s++, c--);
//    lcd.print(s1);
    i=0;
    while (s1[i])
      lcd.print(s1[i++]);  

// Entero sin signo
    sprintf(s3, "millis= %u", millis());
// Coma flotante
    sprintf(s2, "ms/us= %s", dtostrf((float)micros()/millis(), 10, 4, s3));

    lcd.setCursor(20, 0);
    lcd.print(s3);

    lcd.setCursor(64, 0);
    lcd.print(s2);

    delay(1000);
  }

}
